/*
 * linux/include/asm-arm/arch-at91/hardware.h
 *
 *  Copyright (C) 2003 SAN People
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __ASM_ARCH_MATRIX500_H
#define __ASM_ARCH_MATRIX500_H


#ifndef __ASSEMBLY__
#include "AT91RM9200.h"
#else
#include "AT91RM9200_inc.h"
#endif

typedef enum {
	MATRIX500_BUZZER=38,
	MATRIX500_DEBUG_LED1=96,
	MATRIX500_DEBUG_LED2,
	MATRIX500_DEBUG_LED3,
	MATRIX500_DEBUG_LED4,
	MATRIX500_READY_LED=102,
	
} MATRIX500_PIO;

/*#define MATRIX500_DEBUG_LED1	AT91C_PIO_PD0
#define MATRIX500_DEBUG_LED2	AT91C_PIO_PD1
#define MATRIX500_DEBUG_LED3	AT91C_PIO_PD2
#define MATRIX500_DEBUG_LED4	AT91C_PIO_PD3
#define MATRIX500_READY_LED		AT91C_PIO_PD6
#define MATRIX500_BUZZER		AT91C_PIO_PB6
*/
void matrix500_gpio_init(void);
uchar matrix500_gpio_set(MATRIX500_PIO io);
uchar matrix500_gpio_clear(MATRIX500_PIO io);

#endif
