#ifndef STR9100_FLASH_H
#define STR9100_FLASH_H



#ifndef TRUE
#define TRUE			1
#endif

#ifndef FALSE
#define FALSE			0
#endif


/*
 * defines specific to flash
 */
#ifndef MXIC_MX29LV320T
#define MXIC_MX29LV320T         1
#endif

#ifndef MXIC_MX29LV320B
#define MXIC_MX29LV320B         2 
#endif
 
#ifndef FLASH_TYPE
#define FLASH_TYPE              MXIC_MX29LV320B 
#endif 
 
#if (FLASH_TYPE == MXIC_MX29LV320B)

#define MAX_SECTOR_INDEX        70   // index is from 0 to MAX_SECTOR_INDEX
    
#define FLASH_MANUFACTURE_ID    0xC2   // for MXIC_MX29LV320B Byte mode
#define FLASH_DEVICE_ID         0xA8   // for MXIC_MX29LV320B Byte mode

#define FLASH_BYTES_SIZE        (4 * 1024 * 1024)        // 4M bytes per Flash chip
#define FLASH_WORDS_SIZE        (FLASH_BYTES_SIZE >> 1)  // 2 bytes per word

#define NUM_OF_FLASH_CHIPS      2    // number of flash chips on PCB board

#ifndef K
#define K                       (1 << 10) 
#endif

#define SA0_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA1_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA2_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA3_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA4_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA5_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA6_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA7_SIZE                ( 8 * K * NUM_OF_FLASH_CHIPS)

#define SA8_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA9_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA10_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA11_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA12_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA13_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA14_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA15_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA16_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA17_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA18_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA19_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA20_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA21_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA22_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA23_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA24_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA25_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA26_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA27_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA28_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA29_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA30_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA31_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA32_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA33_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA34_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA35_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA36_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA37_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA38_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA39_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA40_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA41_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA42_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA43_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA44_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA45_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA46_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA47_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA48_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA49_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA50_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA51_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA52_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA53_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA54_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA55_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA56_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA57_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA58_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA59_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA60_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA61_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA62_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA63_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA64_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA65_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA66_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA67_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA68_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA69_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA70_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)


#define DATA_POLL_MASK          0x8080  // Q7 bit
#define TOGGLE_BIT_MASK         0x4040  // Q6 bit
#define TIME_OUT_MASK           0x2020  // Q5 bit



#define SYSTEM_FLASH_BASE_ADDR  0x10000000  // depending on system memory mapping

#define SYSTEM_FLASH_MAX_ADDR   (SYSTEM_FLASH_BASE_ADDR + (FLASH_BYTES_SIZE * NUM_OF_FLASH_CHIPS))

#define SA0_BASE_ADDR           (SYSTEM_FLASH_BASE_ADDR)

#define SA1_BASE_ADDR           (SA0_BASE_ADDR + SA0_SIZE)
#define SA2_BASE_ADDR           (SA1_BASE_ADDR + SA1_SIZE)
#define SA3_BASE_ADDR           (SA2_BASE_ADDR + SA2_SIZE)
#define SA4_BASE_ADDR           (SA3_BASE_ADDR + SA3_SIZE)
#define SA5_BASE_ADDR           (SA4_BASE_ADDR + SA4_SIZE)
#define SA6_BASE_ADDR           (SA5_BASE_ADDR + SA5_SIZE)
#define SA7_BASE_ADDR           (SA6_BASE_ADDR + SA6_SIZE)
#define SA8_BASE_ADDR           (SA7_BASE_ADDR + SA7_SIZE)
#define SA9_BASE_ADDR           (SA8_BASE_ADDR + SA8_SIZE)
#define SA10_BASE_ADDR          (SA9_BASE_ADDR + SA9_SIZE)

#define SA11_BASE_ADDR          (SA10_BASE_ADDR + SA10_SIZE)
#define SA12_BASE_ADDR          (SA11_BASE_ADDR + SA11_SIZE)
#define SA13_BASE_ADDR          (SA12_BASE_ADDR + SA12_SIZE)
#define SA14_BASE_ADDR          (SA13_BASE_ADDR + SA13_SIZE)
#define SA15_BASE_ADDR          (SA14_BASE_ADDR + SA14_SIZE)
#define SA16_BASE_ADDR          (SA15_BASE_ADDR + SA15_SIZE)
#define SA17_BASE_ADDR          (SA16_BASE_ADDR + SA16_SIZE)
#define SA18_BASE_ADDR          (SA17_BASE_ADDR + SA17_SIZE)
#define SA19_BASE_ADDR          (SA18_BASE_ADDR + SA18_SIZE)
#define SA20_BASE_ADDR          (SA19_BASE_ADDR + SA19_SIZE)

#define SA21_BASE_ADDR          (SA20_BASE_ADDR + SA20_SIZE)
#define SA22_BASE_ADDR          (SA21_BASE_ADDR + SA21_SIZE)
#define SA23_BASE_ADDR          (SA22_BASE_ADDR + SA22_SIZE)
#define SA24_BASE_ADDR          (SA23_BASE_ADDR + SA23_SIZE)
#define SA25_BASE_ADDR          (SA24_BASE_ADDR + SA24_SIZE)
#define SA26_BASE_ADDR          (SA25_BASE_ADDR + SA25_SIZE)
#define SA27_BASE_ADDR          (SA26_BASE_ADDR + SA26_SIZE)
#define SA28_BASE_ADDR          (SA27_BASE_ADDR + SA27_SIZE)
#define SA29_BASE_ADDR          (SA28_BASE_ADDR + SA28_SIZE)
#define SA30_BASE_ADDR          (SA29_BASE_ADDR + SA29_SIZE)

#define SA31_BASE_ADDR          (SA30_BASE_ADDR + SA30_SIZE)
#define SA32_BASE_ADDR          (SA31_BASE_ADDR + SA31_SIZE)
#define SA33_BASE_ADDR          (SA32_BASE_ADDR + SA32_SIZE)
#define SA34_BASE_ADDR          (SA33_BASE_ADDR + SA33_SIZE)
#define SA35_BASE_ADDR          (SA34_BASE_ADDR + SA34_SIZE)
#define SA36_BASE_ADDR          (SA35_BASE_ADDR + SA35_SIZE)
#define SA37_BASE_ADDR          (SA36_BASE_ADDR + SA36_SIZE)
#define SA38_BASE_ADDR          (SA37_BASE_ADDR + SA37_SIZE)
#define SA39_BASE_ADDR          (SA38_BASE_ADDR + SA38_SIZE)
#define SA40_BASE_ADDR          (SA39_BASE_ADDR + SA39_SIZE)

#define SA41_BASE_ADDR          (SA40_BASE_ADDR + SA40_SIZE)
#define SA42_BASE_ADDR          (SA41_BASE_ADDR + SA41_SIZE)
#define SA43_BASE_ADDR          (SA42_BASE_ADDR + SA42_SIZE)
#define SA44_BASE_ADDR          (SA43_BASE_ADDR + SA43_SIZE)
#define SA45_BASE_ADDR          (SA44_BASE_ADDR + SA44_SIZE)
#define SA46_BASE_ADDR          (SA45_BASE_ADDR + SA45_SIZE)
#define SA47_BASE_ADDR          (SA46_BASE_ADDR + SA46_SIZE)
#define SA48_BASE_ADDR          (SA47_BASE_ADDR + SA47_SIZE)
#define SA49_BASE_ADDR          (SA48_BASE_ADDR + SA48_SIZE)
#define SA50_BASE_ADDR          (SA49_BASE_ADDR + SA49_SIZE)

#define SA51_BASE_ADDR          (SA50_BASE_ADDR + SA50_SIZE)
#define SA52_BASE_ADDR          (SA51_BASE_ADDR + SA51_SIZE)
#define SA53_BASE_ADDR          (SA52_BASE_ADDR + SA52_SIZE)
#define SA54_BASE_ADDR          (SA53_BASE_ADDR + SA53_SIZE)
#define SA55_BASE_ADDR          (SA54_BASE_ADDR + SA54_SIZE)
#define SA56_BASE_ADDR          (SA55_BASE_ADDR + SA55_SIZE)
#define SA57_BASE_ADDR          (SA56_BASE_ADDR + SA56_SIZE)
#define SA58_BASE_ADDR          (SA57_BASE_ADDR + SA57_SIZE)
#define SA59_BASE_ADDR          (SA58_BASE_ADDR + SA58_SIZE)
#define SA60_BASE_ADDR          (SA59_BASE_ADDR + SA59_SIZE)

#define SA61_BASE_ADDR          (SA60_BASE_ADDR + SA60_SIZE)
#define SA62_BASE_ADDR          (SA61_BASE_ADDR + SA61_SIZE)
#define SA63_BASE_ADDR          (SA62_BASE_ADDR + SA62_SIZE)
#define SA64_BASE_ADDR          (SA63_BASE_ADDR + SA63_SIZE)
#define SA65_BASE_ADDR          (SA64_BASE_ADDR + SA64_SIZE)
#define SA66_BASE_ADDR          (SA65_BASE_ADDR + SA65_SIZE)
#define SA67_BASE_ADDR          (SA66_BASE_ADDR + SA66_SIZE)
#define SA68_BASE_ADDR          (SA67_BASE_ADDR + SA67_SIZE)
#define SA69_BASE_ADDR          (SA68_BASE_ADDR + SA68_SIZE)
#define SA70_BASE_ADDR          (SA69_BASE_ADDR + SA69_SIZE)


#define BIT_SHIFT_NUM           1

#define MANUFACTURE_ID_ADDR     (SA0_BASE_ADDR | (0x00 << BIT_SHIFT_NUM))
#define DEVICE_ID_ADDR          (SA0_BASE_ADDR | (0x02 << BIT_SHIFT_NUM))


#define DELAY_LOOP              100000

#endif



/*
 * MXIC's flash manufacture ID
 */
#define MX_MANUFACT                     0x00C20000

#define MXIC_MANUFACTURE_ID		0x00C20000


/*
 * MXIC's flash device ID
 */
#define MXIC_DEVICE_ID_MX29LV320B	0x000000A8


/*
 * SST's flash manufacture ID
 */
//#define SST_MANUFACT			0x00bf0000


/*
 * SST's flash device ID
 */
#define SST_ID_39VF080			0xd8
#define SST_ID_39VF016			0xd9


/*
 * Intel's flash manufacture ID
 */
//#define INTEL_MANUFACT		0x00890000


/*
 * Intel's flash device ID
 */
#define INTEL_ID_E28F128		0x18

#define INTEL_E28F128_SIZE		(0x1000000)


#define FLASH_SINGLE			(0x00)
#define FLASH_DOUBLE			(0x01)
#define FLASH_FOUR			(0x02)


#define MX_Type         		(0x01)
#define SST_Type        		(0x02)
#define Intel_Type     		 	(0x03)



#define PROGRAM_OK			(1)
#define PROGRAM_NOT_OK			(-2)
#define FLASH_PROGRAM_DELAY_CYCLE	(50)
#define FLASH_PROGRAM_LOOP_COUNTER	(100)



#endif
