#ifndef _MATRIX400_H
#define _MATRIX400_H

#include "star_gpio.h"

#define MATRIX400_RTC_SCLK	GPIO_0_MASK  
#define MATRIX400_RTC_IO	GPIO_1_MASK
#define MATRIX400_RTC_IO_GPIO	1
#define MATRIX400_RTC_REST	GPIO_18_MASK
#define MATRIX400_READY		GPIO_16_MASK
#define MATRIX400_BUZZER	GPIO_17_MASK
#define MATRIX400_I2C_SCL	GPIO_2_MASK
#define MATRIX400_I2C_SDA	GPIO_3_MASK
#define MATRIX400_SDA_GPIO	3
void matrix400_gpio_init(void);

#ifdef CONFIG_SOFT_I2C
//void MATRIX400_I2C_INIT(void);
void MATRIX400_I2C_ACTIVE(void);
void MATRIX400_I2C_TRISTATE(void);
BOOL MATRIX400_I2C_READ(void);
void MATRIX400_SDA(int bit);
void MATRIX400_SCL(int bit);
#define I2C_DELAY	udelay(2)
//#define I2C_INIT	MATRIX400_I2C_INIT()
#define I2C_ACTIVE	MATRIX400_I2C_ACTIVE()
#define I2C_TRISTATE	MATRIX400_I2C_TRISTATE()
#define I2C_READ 	MATRIX400_I2C_READ()
#define I2C_SDA(bit)	MATRIX400_SDA(bit)
#define I2C_SCL(bit)	MATRIX400_SCL(bit)

#endif

#endif
