#ifndef STR9100_FLASH_H
#define STR9100_FLASH_H


#include "config.h"


#ifndef TRUE
#define TRUE			1
#endif

#ifndef FALSE
#define FALSE			0
#endif


/*
 * defines specific to flash
 */
#ifndef MXIC_MX29LV640T
#define MXIC_MX29LV640T         1
#endif

#ifndef MXIC_MX29LV640B
#define MXIC_MX29LV640B         2 
#endif
 
#ifndef FLASH_TYPE
#define FLASH_TYPE              MXIC_MX29LV640T
#endif 
 
 
#if (FLASH_TYPE == MXIC_MX29LV640T)

#define MAX_SECTOR_INDEX        134			// index is from 0 to MAX_SECTOR_INDEX


#define FLASH_BYTES_SIZE        (8 * 1024 * 1024)	// 8M bytes per Flash chip
#define FLASH_WORDS_SIZE        (FLASH_BYTES_SIZE >> 1)	// 2 bytes per word

#define NUM_OF_FLASH_CHIPS      1			// number of flash chips on PCB board


#ifndef K
#define K                       (1 << 10) 
#endif


#define SA0_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA1_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA2_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA3_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA4_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA5_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA6_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA7_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA8_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA9_SIZE                (64 * K * NUM_OF_FLASH_CHIPS)
#define SA10_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA11_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA12_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA13_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA14_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA15_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA16_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA17_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA18_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA19_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA20_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA21_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA22_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA23_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA24_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA25_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA26_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA27_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA28_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA29_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA30_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA31_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA32_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA33_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA34_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA35_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA36_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA37_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA38_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA39_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA40_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA41_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA42_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA43_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA44_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA45_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA46_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA47_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA48_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA49_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA50_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA51_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA52_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA53_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA54_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA55_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA56_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA57_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA58_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA59_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA60_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA61_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA62_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA63_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA64_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA65_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA66_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA67_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA68_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA69_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA70_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA71_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA72_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA73_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA74_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA75_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA76_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA77_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA78_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA79_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA80_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA81_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA82_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA83_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA84_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA85_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA86_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA87_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA88_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA89_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA90_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA91_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA92_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA93_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA94_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA95_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA96_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA97_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA98_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA99_SIZE               (64 * K * NUM_OF_FLASH_CHIPS)
#define SA100_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA101_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA102_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA103_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA104_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA105_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA106_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA107_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA108_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA109_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA110_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA111_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA112_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA113_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA114_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA115_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA116_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA117_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA118_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA119_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA120_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA121_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA122_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA123_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA124_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA125_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)
#define SA126_SIZE              (64 * K * NUM_OF_FLASH_CHIPS)

#define SA127_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA128_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA129_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA130_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA131_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA132_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA133_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)
#define SA134_SIZE              ( 8 * K * NUM_OF_FLASH_CHIPS)


#define DATA_POLL_MASK          0x0080  // Q7 bit
#define TOGGLE_BIT_MASK         0x0040  // Q6 bit
#define TIME_OUT_MASK           0x0020  // Q5 bit



#define SYSTEM_FLASH_BASE_ADDR  CFG_FLASH_BASE

#define SYSTEM_FLASH_MAX_ADDR   (SYSTEM_FLASH_BASE_ADDR + (FLASH_BYTES_SIZE * NUM_OF_FLASH_CHIPS))

#define SA0_BASE_ADDR           (SYSTEM_FLASH_BASE_ADDR)

#define SA1_BASE_ADDR           (SA0_BASE_ADDR + SA0_SIZE)
#define SA2_BASE_ADDR           (SA1_BASE_ADDR + SA1_SIZE)
#define SA3_BASE_ADDR           (SA2_BASE_ADDR + SA2_SIZE)
#define SA4_BASE_ADDR           (SA3_BASE_ADDR + SA3_SIZE)
#define SA5_BASE_ADDR           (SA4_BASE_ADDR + SA4_SIZE)
#define SA6_BASE_ADDR           (SA5_BASE_ADDR + SA5_SIZE)
#define SA7_BASE_ADDR           (SA6_BASE_ADDR + SA6_SIZE)
#define SA8_BASE_ADDR           (SA7_BASE_ADDR + SA7_SIZE)
#define SA9_BASE_ADDR           (SA8_BASE_ADDR + SA8_SIZE)
#define SA10_BASE_ADDR          (SA9_BASE_ADDR + SA9_SIZE)

#define SA11_BASE_ADDR          (SA10_BASE_ADDR + SA10_SIZE)
#define SA12_BASE_ADDR          (SA11_BASE_ADDR + SA11_SIZE)
#define SA13_BASE_ADDR          (SA12_BASE_ADDR + SA12_SIZE)
#define SA14_BASE_ADDR          (SA13_BASE_ADDR + SA13_SIZE)
#define SA15_BASE_ADDR          (SA14_BASE_ADDR + SA14_SIZE)
#define SA16_BASE_ADDR          (SA15_BASE_ADDR + SA15_SIZE)
#define SA17_BASE_ADDR          (SA16_BASE_ADDR + SA16_SIZE)
#define SA18_BASE_ADDR          (SA17_BASE_ADDR + SA17_SIZE)
#define SA19_BASE_ADDR          (SA18_BASE_ADDR + SA18_SIZE)
#define SA20_BASE_ADDR          (SA19_BASE_ADDR + SA19_SIZE)

#define SA21_BASE_ADDR          (SA20_BASE_ADDR + SA20_SIZE)
#define SA22_BASE_ADDR          (SA21_BASE_ADDR + SA21_SIZE)
#define SA23_BASE_ADDR          (SA22_BASE_ADDR + SA22_SIZE)
#define SA24_BASE_ADDR          (SA23_BASE_ADDR + SA23_SIZE)
#define SA25_BASE_ADDR          (SA24_BASE_ADDR + SA24_SIZE)
#define SA26_BASE_ADDR          (SA25_BASE_ADDR + SA25_SIZE)
#define SA27_BASE_ADDR          (SA26_BASE_ADDR + SA26_SIZE)
#define SA28_BASE_ADDR          (SA27_BASE_ADDR + SA27_SIZE)
#define SA29_BASE_ADDR          (SA28_BASE_ADDR + SA28_SIZE)
#define SA30_BASE_ADDR          (SA29_BASE_ADDR + SA29_SIZE)

#define SA31_BASE_ADDR          (SA30_BASE_ADDR + SA30_SIZE)
#define SA32_BASE_ADDR          (SA31_BASE_ADDR + SA31_SIZE)
#define SA33_BASE_ADDR          (SA32_BASE_ADDR + SA32_SIZE)
#define SA34_BASE_ADDR          (SA33_BASE_ADDR + SA33_SIZE)
#define SA35_BASE_ADDR          (SA34_BASE_ADDR + SA34_SIZE)
#define SA36_BASE_ADDR          (SA35_BASE_ADDR + SA35_SIZE)
#define SA37_BASE_ADDR          (SA36_BASE_ADDR + SA36_SIZE)
#define SA38_BASE_ADDR          (SA37_BASE_ADDR + SA37_SIZE)
#define SA39_BASE_ADDR          (SA38_BASE_ADDR + SA38_SIZE)
#define SA40_BASE_ADDR          (SA39_BASE_ADDR + SA39_SIZE)

#define SA41_BASE_ADDR          (SA40_BASE_ADDR + SA40_SIZE)
#define SA42_BASE_ADDR          (SA41_BASE_ADDR + SA41_SIZE)
#define SA43_BASE_ADDR          (SA42_BASE_ADDR + SA42_SIZE)
#define SA44_BASE_ADDR          (SA43_BASE_ADDR + SA43_SIZE)
#define SA45_BASE_ADDR          (SA44_BASE_ADDR + SA44_SIZE)
#define SA46_BASE_ADDR          (SA45_BASE_ADDR + SA45_SIZE)
#define SA47_BASE_ADDR          (SA46_BASE_ADDR + SA46_SIZE)
#define SA48_BASE_ADDR          (SA47_BASE_ADDR + SA47_SIZE)
#define SA49_BASE_ADDR          (SA48_BASE_ADDR + SA48_SIZE)
#define SA50_BASE_ADDR          (SA49_BASE_ADDR + SA49_SIZE)

#define SA51_BASE_ADDR          (SA50_BASE_ADDR + SA50_SIZE)
#define SA52_BASE_ADDR          (SA51_BASE_ADDR + SA51_SIZE)
#define SA53_BASE_ADDR          (SA52_BASE_ADDR + SA52_SIZE)
#define SA54_BASE_ADDR          (SA53_BASE_ADDR + SA53_SIZE)
#define SA55_BASE_ADDR          (SA54_BASE_ADDR + SA54_SIZE)
#define SA56_BASE_ADDR          (SA55_BASE_ADDR + SA55_SIZE)
#define SA57_BASE_ADDR          (SA56_BASE_ADDR + SA56_SIZE)
#define SA58_BASE_ADDR          (SA57_BASE_ADDR + SA57_SIZE)
#define SA59_BASE_ADDR          (SA58_BASE_ADDR + SA58_SIZE)
#define SA60_BASE_ADDR          (SA59_BASE_ADDR + SA59_SIZE)

#define SA61_BASE_ADDR          (SA60_BASE_ADDR + SA60_SIZE)
#define SA62_BASE_ADDR          (SA61_BASE_ADDR + SA61_SIZE)
#define SA63_BASE_ADDR          (SA62_BASE_ADDR + SA62_SIZE)
#define SA64_BASE_ADDR          (SA63_BASE_ADDR + SA63_SIZE)
#define SA65_BASE_ADDR          (SA64_BASE_ADDR + SA64_SIZE)
#define SA66_BASE_ADDR          (SA65_BASE_ADDR + SA65_SIZE)
#define SA67_BASE_ADDR          (SA66_BASE_ADDR + SA66_SIZE)
#define SA68_BASE_ADDR          (SA67_BASE_ADDR + SA67_SIZE)
#define SA69_BASE_ADDR          (SA68_BASE_ADDR + SA68_SIZE)
#define SA70_BASE_ADDR          (SA69_BASE_ADDR + SA69_SIZE)

#define SA71_BASE_ADDR          (SA70_BASE_ADDR + SA70_SIZE)
#define SA72_BASE_ADDR          (SA71_BASE_ADDR + SA71_SIZE)
#define SA73_BASE_ADDR          (SA72_BASE_ADDR + SA72_SIZE)
#define SA74_BASE_ADDR          (SA73_BASE_ADDR + SA73_SIZE)
#define SA75_BASE_ADDR          (SA74_BASE_ADDR + SA74_SIZE)
#define SA76_BASE_ADDR          (SA75_BASE_ADDR + SA75_SIZE)
#define SA77_BASE_ADDR          (SA76_BASE_ADDR + SA76_SIZE)
#define SA78_BASE_ADDR          (SA77_BASE_ADDR + SA77_SIZE)
#define SA79_BASE_ADDR          (SA78_BASE_ADDR + SA78_SIZE)
#define SA80_BASE_ADDR          (SA79_BASE_ADDR + SA79_SIZE)

#define SA81_BASE_ADDR          (SA80_BASE_ADDR + SA80_SIZE)
#define SA82_BASE_ADDR          (SA81_BASE_ADDR + SA81_SIZE)
#define SA83_BASE_ADDR          (SA82_BASE_ADDR + SA82_SIZE)
#define SA84_BASE_ADDR          (SA83_BASE_ADDR + SA83_SIZE)
#define SA85_BASE_ADDR          (SA84_BASE_ADDR + SA84_SIZE)
#define SA86_BASE_ADDR          (SA85_BASE_ADDR + SA85_SIZE)
#define SA87_BASE_ADDR          (SA86_BASE_ADDR + SA86_SIZE)
#define SA88_BASE_ADDR          (SA87_BASE_ADDR + SA87_SIZE)
#define SA89_BASE_ADDR          (SA88_BASE_ADDR + SA88_SIZE)
#define SA90_BASE_ADDR          (SA89_BASE_ADDR + SA89_SIZE)

#define SA91_BASE_ADDR          (SA90_BASE_ADDR + SA90_SIZE)
#define SA92_BASE_ADDR          (SA91_BASE_ADDR + SA91_SIZE)
#define SA93_BASE_ADDR          (SA92_BASE_ADDR + SA92_SIZE)
#define SA94_BASE_ADDR          (SA93_BASE_ADDR + SA93_SIZE)
#define SA95_BASE_ADDR          (SA94_BASE_ADDR + SA94_SIZE)
#define SA96_BASE_ADDR          (SA95_BASE_ADDR + SA95_SIZE)
#define SA97_BASE_ADDR          (SA96_BASE_ADDR + SA96_SIZE)
#define SA98_BASE_ADDR          (SA97_BASE_ADDR + SA97_SIZE)
#define SA99_BASE_ADDR          (SA98_BASE_ADDR + SA98_SIZE)
#define SA100_BASE_ADDR         (SA99_BASE_ADDR + SA99_SIZE)

#define SA101_BASE_ADDR         (SA100_BASE_ADDR + SA100_SIZE)
#define SA102_BASE_ADDR         (SA101_BASE_ADDR + SA101_SIZE)
#define SA103_BASE_ADDR         (SA102_BASE_ADDR + SA102_SIZE)
#define SA104_BASE_ADDR         (SA103_BASE_ADDR + SA103_SIZE)
#define SA105_BASE_ADDR         (SA104_BASE_ADDR + SA104_SIZE)
#define SA106_BASE_ADDR         (SA105_BASE_ADDR + SA105_SIZE)
#define SA107_BASE_ADDR         (SA106_BASE_ADDR + SA106_SIZE)
#define SA108_BASE_ADDR         (SA107_BASE_ADDR + SA107_SIZE)
#define SA109_BASE_ADDR         (SA108_BASE_ADDR + SA108_SIZE)
#define SA110_BASE_ADDR         (SA109_BASE_ADDR + SA109_SIZE)

#define SA111_BASE_ADDR         (SA110_BASE_ADDR + SA110_SIZE)
#define SA112_BASE_ADDR         (SA111_BASE_ADDR + SA111_SIZE)
#define SA113_BASE_ADDR         (SA112_BASE_ADDR + SA112_SIZE)
#define SA114_BASE_ADDR         (SA113_BASE_ADDR + SA113_SIZE)
#define SA115_BASE_ADDR         (SA114_BASE_ADDR + SA114_SIZE)
#define SA116_BASE_ADDR         (SA115_BASE_ADDR + SA115_SIZE)
#define SA117_BASE_ADDR         (SA116_BASE_ADDR + SA116_SIZE)
#define SA118_BASE_ADDR         (SA117_BASE_ADDR + SA117_SIZE)
#define SA119_BASE_ADDR         (SA118_BASE_ADDR + SA118_SIZE)
#define SA120_BASE_ADDR         (SA119_BASE_ADDR + SA119_SIZE)

#define SA121_BASE_ADDR         (SA120_BASE_ADDR + SA120_SIZE)
#define SA122_BASE_ADDR         (SA121_BASE_ADDR + SA121_SIZE)
#define SA123_BASE_ADDR         (SA122_BASE_ADDR + SA122_SIZE)
#define SA124_BASE_ADDR         (SA123_BASE_ADDR + SA123_SIZE)
#define SA125_BASE_ADDR         (SA124_BASE_ADDR + SA124_SIZE)
#define SA126_BASE_ADDR         (SA125_BASE_ADDR + SA125_SIZE)
#define SA127_BASE_ADDR         (SA126_BASE_ADDR + SA126_SIZE)
#define SA128_BASE_ADDR         (SA127_BASE_ADDR + SA127_SIZE)
#define SA129_BASE_ADDR         (SA128_BASE_ADDR + SA128_SIZE)
#define SA130_BASE_ADDR         (SA129_BASE_ADDR + SA129_SIZE)

#define SA131_BASE_ADDR         (SA130_BASE_ADDR + SA130_SIZE)
#define SA132_BASE_ADDR         (SA131_BASE_ADDR + SA131_SIZE)
#define SA133_BASE_ADDR         (SA132_BASE_ADDR + SA132_SIZE)
#define SA134_BASE_ADDR         (SA133_BASE_ADDR + SA133_SIZE)



#define BIT_SHIFT_NUM           (1)

#define MANUFACTURE_ID_ADDR     (SA0_BASE_ADDR | (0x00 << BIT_SHIFT_NUM))
#define DEVICE_ID_ADDR          (SA0_BASE_ADDR | (0x01 << BIT_SHIFT_NUM))


#define DELAY_LOOP              100000



/*
 * MXIC's flash manufacture ID
 */
#define MXIC_MANUFACTURE_ID		0x00C20000	// 0x00C2 at high 16-bit


/*
 * MXIC's flash device ID
 */
#define MXIC_DEVICE_ID_MX29LV640T	0x000022C9	// 0c22C9 at low 16-bit

#endif



#define FLASH_SINGLE			(0x00)
#define FLASH_DOUBLE			(0x01)
#define FLASH_FOUR			(0x02)


#define MX_Type         		(0x01)
#define SST_Type        		(0x02)
#define Intel_Type     		 	(0x03)



#define PROGRAM_OK			(1)
#define PROGRAM_NOT_OK			(-2)
#define FLASH_PROGRAM_DELAY_CYCLE	(50)
#define FLASH_PROGRAM_LOOP_COUNTER	(100)



#endif
