#ifndef SYMBOL_H
#define SYMBOL_H



/* ASCII symbol define */
#define CR		0x0D
#define LF		0x0A
#define BS		0x08
#define ESC 		27


/* These defines are in a common coding practices header file */
#ifndef	ERROR
#define ERROR		-1
#endif

#ifndef	FALSE
#define FALSE		0
#endif

#ifndef	TRUE
#define TRUE		1
#endif

#ifndef	NULL
#define	NULL		0
#endif

#ifndef ON
#define ON		1
#endif

#ifndef OFF
#define	OFF		0
#endif


#ifndef ENABLE
#define ENABLE		1
#endif

#ifndef DISABLE
#define	DISABLE		0
#endif

#ifndef PARITY_NONE
#define PARITY_NONE	0
#endif

#ifndef PARITY_ODD
#define PARITY_ODD	1
#endif

#ifndef PARITY_EVEN
#define PARITY_EVEN	2
#endif

#ifndef PARITY_MARK
#define PARITY_MARK	3
#endif

#ifndef PARITY_SPACE
#define PARITY_SPACE	4
#endif


/* type define */
typedef unsigned long long	UINT64;
typedef long long		INT64;
typedef	unsigned int		UINT32;
typedef	int			INT32;
typedef	unsigned short		UINT16;
typedef	short			INT16;
typedef unsigned char		UINT8;
typedef char			INT8;
typedef unsigned char		BOOL;



#endif
