#ifndef _STAR_LED_H_
#define _STAR_LED_H_

/******************************************************************************
 * MODULE NAME:    star_led.h
 * PROJECT CODE:   Orion
 * DESCRIPTION:    
 * MAINTAINER:     MJLIU
 * DATE:           30 June 2003
 *
 * SOURCE CONTROL: 
 *
 * LICENSE:
 *     This source code is copyright (c) 2003 Star Semi Inc.
 *     All rights reserved.
 *
 * REVISION HISTORY:
 *    30 June 2003  -  MJLIU	- Initial Version v1.0
 *
 *
 * SOURCE:
 * ISSUES:
 * NOTES TO USERS:
 ******************************************************************************/

#include "star_gpio.h"


#define MAX_LED_NUMBER    21

#define LED_0_MASK        GPIO_0_MASK
#define LED_1_MASK        GPIO_1_MASK
#define LED_2_MASK        GPIO_2_MASK
#define LED_3_MASK        GPIO_3_MASK
#define LED_4_MASK        GPIO_4_MASK
#define LED_5_MASK        GPIO_5_MASK
#define LED_6_MASK        GPIO_6_MASK
#define LED_7_MASK        GPIO_7_MASK
#define LED_8_MASK        GPIO_8_MASK
#define LED_9_MASK        GPIO_9_MASK
#define LED_10_MASK       GPIO_10_MASK
#define LED_11_MASK       GPIO_11_MASK
#define LED_12_MASK       GPIO_12_MASK
#define LED_13_MASK       GPIO_13_MASK
#define LED_14_MASK       GPIO_14_MASK
#define LED_15_MASK       GPIO_15_MASK

#define LED_16_MASK       GPIO_16_MASK
#define LED_17_MASK       GPIO_17_MASK
#define LED_18_MASK       GPIO_18_MASK
#define LED_19_MASK       GPIO_19_MASK
#define LED_20_MASK       GPIO_20_MASK



#define LED_ALL_MASK      0x001FFFFF


/*
 * functions declarations
 */
void    Hal_Led_Initialize(void);

void    Hal_Led_All_On(void);

void    Hal_Led_All_Off(void);

void    Hal_Led_On(u_int32);

void    Hal_Led_Off(u_int32);

void    Hal_Led_Toggle(u_int32);


#endif  // end of _STAR_LED_H_